clear
format compact

rotorpend_para

% -----------------------------------------
% xZo{[pXtB^
% flag = 1;   %% 0 z[h
flag = 2;   %% oꎟϊ

% -----------------------------------------
Tf1 = 0.02;
Tf2 = 0.05;

% ts = 0.005;
ts = 0.01;

% --------------------------------------
E = [ 1  0  0  0
      0  1  0  0
      0  0  1  0
      0  0  m2*L1*l2  J2+m2*l2^2 ];
F = [ 0  0  1  0
      0  0  0  1
      0  0 -a  0
      0  m2*l2*g  0  -c2 ];
G = [ 0
      0
      b
      0 ];

A = inv(E)*F;
B = inv(E)*G;

eig(A)

% --------------------------------
q1 = 50;
q2 = 1;
q3 = 0.01;
q4 = 0.01;

R = 1;
Q = diag([q1 q2 q3 q4]);

K = -lqr(A,B,Q,R)

eig(A + B*K)

% --------------------------------
% p = [-2+j
%      -2-j
%      -3+3j
%      -3-3j]*2
%  
% K = -acker(A,B,p)

% +++++++++++++++++++++++++++++++++++++++++
% +++++++++++++++++++++++++++++++++++++++++
Af1 = - 1/Tf1;
Bf1 =   1/Tf1;
Cf1 = - 1/Tf1;
Df1 =   1/Tf1;

Af2 = - 1/Tf2;
Bf2 =   1/Tf2;
Cf2 = - 1/Tf2;
Df2 =   1/Tf2;

sysPfc1 = ss(Af1,Bf1,Cf1,Df1);
sysPfc2 = ss(Af2,Bf2,Cf2,Df2);

if flag == 1
    % 0 z[h
    sysPfd1 = c2d(sysPfc1,ts,'zoh');
    sysPfd2 = c2d(sysPfc2,ts,'zoh');
    [Afd1 Bfd1 Cfd1 Dfd1] = ssdata(sysPfd1);
    [Afd2 Bfd2 Cfd2 Dfd2] = ssdata(sysPfd2);
elseif flag == 2
    % oꎟϊ
    sysPfd1 = c2d(sysPfc1,ts,'tustin');
    sysPfd2 = c2d(sysPfc2,ts,'tustin');
    [Afd1 Bfd1 Cfd1 Dfd1] = ssdata(sysPfd1);
    [Afd2 Bfd2 Cfd2 Dfd2] = ssdata(sysPfd2);
end
